//
//  TI_ADS8699.hpp
//  
//
//  Created by Brecky Morris on 6/21/20.
//

#ifndef TI_ADS8699_hpp
#define TI_ADS8699_hpp

#include <stdio.h>

#endif /* TI_ADS8699_hpp */

#define BIPOLAR_3x_VREF                     1 // 0000b = ±3 × VREF
#define BIPOLAR_2POINT5x_VREF               2 // 0001b = ±2.5 × VREF
#define BIPOLAR_1POINT5x_VREF               3 // 0010b = ±1.5 × VREF
#define BIPOLAR_1POINT25x_VREF              4 // 0011b = ±1.25 × VREF
#define BIPOLAR_POINT625x_VREF              5 // 0100b = ±0.625 × VREF
#define UNIPOLAR_3x_VREF                    6 // 1000b = 3 × VREF
#define UNIPOLAR_2POINT5x_VREF              7 // 1001b = 2.5 × VREF
#define UNIPOLAR_1POINT5x_VREF              8 // 1010b = 1.5 × VREF
#define UNIPOLAR_1POINT25x_VREF             9 // 1011b = 1.25 × VREF

#define BIPOLAR_3x_VREF_BIN_VAL             0b0000
#define BIPOLAR_2POINT5x_VREF_BIN_VAL       0b0001
#define BIPOLAR_1POINT5x_VREF_BIN_VAL       0b0010
#define BIPOLAR_1POINT25x_VREF_BIN_VAL      0b0011
#define BIPOLAR_POINT625x_VREF_BIN_VAL      0b0100
#define UNIPOLAR_3x_VREF_BIN_VAL            0b1000
#define UNIPOLAR_2POINT5x_VREF_BIN_VAL      0b1001
#define UNIPOLAR_1POINT5x_VREF_BIN_VAL      0b1010
#define UNIPOLAR_1POINT25x_VREF_BIN_VAL     0b1011

#define BIPOLAR_3x_VREF_VAL                 3
#define BIPOLAR_2POINT5x_VREF_VAL           2.5
#define BIPOLAR_1POINT5x_VREF_VAL           1.5
#define BIPOLAR_1POINT25x_VREF_VAL          1.25
#define BIPOLAR_POINT625x_VREF_VAL          0.625
#define UNIPOLAR_3x_VREF_VAL                3
#define UNIPOLAR_2POINT5x_VREF_VAL          2.5
#define UNIPOLAR_1POINT5x_VREF_VAL          1.5
#define UNIPOLAR_1POINT25x_VREF_VAL         1.25

#define WRITE                               0xD000
#define RANGE_SEL_REG                       0x14

#define INTERNAL_REFERENCE                  4.096

class TI_ADS8699
{

public:
    TI_ADS8699(uint8_t adc_chip_select, uint8_t adc_reset);
    double readADC(int range);
    bool begin();

public:
    // uint8_t adc_chip_select;
    // uint8_t adc_reset;
};

